#include <iostream>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long n, k;
    cin >> n >> k;
    long long d[k];
    for(int i = 0; i < k; i++){
        long long x, s = 0;
        cin >> x;
        for(long long j = 1; j <= x; j++){
            if(x % j == 0){
                s = s ^ j;
            }
        }
        d[i] = s;
    }
    for(int i = 0; i < k; i++){
        cout << d[i] << " ";
    }
    return 0;
}